/*
Code automatically generated by asn1scc tool
*/
#include <limits.h>
#include <string.h>
#include <math.h>
#include "DepthMap.h"

#if !defined(_MSC_VER) || _MSC_VER >= 1800
void Depth_validity_t_Initialize(Depth_validity_t* pVal)
{
  *pVal = (Depth_validity_t) depth_valid;
}
#endif


flag Depth_validity_t_IsConstraintValid(const Depth_validity_t* pVal, int* pErrCode)
{

  flag ret = TRUE;
  *pErrCode=0;

  (void)pVal;

  ret = ((((*pVal == depth_valid) || (*pVal == depth_range_error)) || (*pVal == depth_range_error_far))
         || (*pVal == depth_range_error_near));
  *pErrCode = ret ? 0 : ERR_Depth_validity_t;

  return ret;
}

flag Depth_validity_t_Encode(const Depth_validity_t* pVal, BitStream* pBitStrm, int* pErrCode, flag bCheckConstraints)
{
  flag ret = TRUE;

  ret = bCheckConstraints ? Depth_validity_t_IsConstraintValid(pVal, pErrCode) : TRUE ;
  if (ret)
    {
      switch(*pVal)
        {
        case depth_valid:
          BitStream_EncodeConstraintWholeNumber(pBitStrm, 0, 0, 3);
          break;
        case depth_range_error:
          BitStream_EncodeConstraintWholeNumber(pBitStrm, 1, 0, 3);
          break;
        case depth_range_error_far:
          BitStream_EncodeConstraintWholeNumber(pBitStrm, 2, 0, 3);
          break;
        case depth_range_error_near:
          BitStream_EncodeConstraintWholeNumber(pBitStrm, 3, 0, 3);
          break;
        default:
          *pErrCode = 1075838977; //COVERAGE_IGNORE
          ret = FALSE;            //COVERAGE_IGNORE
        }
    }

  return ret;
}

flag Depth_validity_t_Decode(Depth_validity_t* pVal, BitStream* pBitStrm, int* pErrCode)
{
  flag ret = TRUE;
  asn1SccSint enumIndex;

  ret = BitStream_DecodeConstraintWholeNumber(pBitStrm, &enumIndex, 0, 3);
  *pErrCode = ret ? 0 : 270532609;
  if (ret)
    {
      switch(enumIndex)
        {
        case 0:
          *pVal = depth_valid;
          break;
        case 1:
          *pVal = depth_range_error;
          break;
        case 2:
          *pVal = depth_range_error_far;
          break;
        case 3:
          *pVal = depth_range_error_near;
          break;
        default:
          *pErrCode = 1075838978;     //COVERAGE_IGNORE
          ret = FALSE;                //COVERAGE_IGNORE
        }
    }

  return ret;
}

